Subject: DLSw ACTION ITEM: Correlators

From: [email-masked] (Paul Brittain)
Date: Thu, 30 Jun 94 17:31:04 BST

Connect RIGlet,

In Raleigh we discussed the need to tighten up the text describing how the 3
correlator fields in the SSP format may vary during circuit setup.  The
proposed text below incorporates Steve Klein's wording on when these fields are
fixed, but tightens up the defintion to ensure that all implementations allow
for these fields to vary up to that point.

Note that I have used the term 'vary' to indicate that the receiver of a
correlator field really should not be trying to interpret it at all even to the
extent of saying 'If it is now non-zero I can safely assume this value from now
on'.  It is much safer and more flexible to require that the receiver continues
to reflect the values last received from the sender up until the circuit is
established and the REACH_ACK has flowed.

The Transport ID I have left as a specifal case as per the current RFC (but not
mentioned in Steve's proposal) to give one correlator field that can be relied
on in every SSP control message after the CAP-ex, in particular for DATAFRAMEs.

I have tried to specify the exchange of these correlators in a way that allows
for any future messages that may be added to SSP circuit startup flows, so
please don't worry if you can't think of any messages that the Target can send
to the Origin DLSw before the ICANREACH_cs!

I have also tried to use 'must', 'should' and 'may' in the appropriate
contexts.  Please comment if you think any of these need to be weakened or
strengthened.

Paul Brittain
Data Connection.

Proposed Text:
==============

USE OF CORRELATOR FIELDS
------------------------

The use and contents of the Data Link Correlator, Port ID and Transport
ID fields in SSP messages is an implementation choice.  These fields have local
significance only and the values received from a partner DLSw must not be
interpreted by the DLSw that receives them.

However for correct interoperation, all implementations must obey the following
rules on the assignment and fixing of these correlator fields for each
transport connection or circuit:

-       The Transport ID fields are learnt from the first SSP message exchanged
        with a DLSw partner (the Capabilities exchange).  This field should
        not be varied by a DLSw after the capabilities exchange and must be
        reflected to the partner DLSw in every SSP control message.

-       The Target Data Link Correlator, Target Port ID and Target Transport ID
        must remain the same once the Target DLSw has sent the ICANREACH_cs
        for a given circuit.  The Origin DLSw must store the values specified
        in the ICANREACH_cs and use these on all subsequent SSP messages for
        this circuit.

        The Origin DLSw must allow these fields to vary until the ICANREACH_cs
        is received.  Each SSP message issued for a circuit must reflect the
        values specified by the Target DLSw in the last SSP message for this
        circuit received by the Origin DLSw.  Binary zero should be used if no
        such message has yet been received for a given circuit (apart from the
        Target Transport ID which will have been learnt as specified above).

-       The Origin Data Link Correlator, Origin Port ID and Origin Transport ID
        must remain the same once the Origin DLSw has issued the REACH_ACK for
        a given circuit.  The Target DLSw must store the values specified in
        the REACH_ACK and use these on all subsequent SSP messages for this
        circuit.

        The Target DLSw must allow these fields to vary until the REACH_ACK
        is received.  Each SSP message issued for a circuit must reflect the
        values specified by the Origin DLSw in the last SSP message for this
        circuit received by the Target DLSw.  Binary zero should be used if no
        such message has yet been received for a given circuit (apart from the
        Origin Transport ID which will have been learnt as specified above).

-       For the purposes of correlator exchange, explorer messages form a
        separate circuit.  Both DLSw partners must reflect the last received
        correlator values as specified above.  However correlators learnt
        on explorer messages need not be carried over to a subsequent circuit
        setup attempt.  In particular, the Origin DLSw may elect to use the
        same values for the Origin Data Link Correlator and Origin Port ID
        when it issues a CANUREACH_cs after receiving an ICANREACH_ex or
        NETBIOS_NR_ex.  However the Target DLSw must not assume
        that the CANUREACH_cs will specify any of the Target Data Link
        Correlator or Target Port ID that were exchanged on the explorer
        frames.